from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, Float

Inchworm_V0_1_0 = CommandToolBuilder(tool="inchworm", base_command=["inchworm"], inputs=[ToolInput(tag="in_reads", input_type=Boolean(optional=True), prefix="--reads", doc=InputDocumentation(doc="<str>             :fasta file containing reads")), ToolInput(tag="in_km_ers", input_type=Boolean(optional=True), prefix="--kmers", doc=InputDocumentation(doc="<str>             :fasta file containing kmers")), ToolInput(tag="in_km_er_files_listing", input_type=File(optional=True), prefix="--kmer_files_listing", doc=InputDocumentation(doc=":file listing filenames containing kmers")), ToolInput(tag="in_run_inchworm", input_type=Boolean(optional=True), prefix="--run_inchworm", doc=InputDocumentation(doc=":run inchworm, report sequences")), ToolInput(tag="in_kmer_length_default", input_type=Int(optional=True), prefix="-K", doc=InputDocumentation(doc=":kmer length (default: 25, meaning 24mer overlaps)  max = 32 (stored as 64-bit integers, 2-base char encoding)")), ToolInput(tag="in_mink_mer_count", input_type=Int(optional=True), prefix="--minKmerCount", doc=InputDocumentation(doc=":min kmer count, lower abundant kmers are pruned from graph (default: 1)")), ToolInput(tag="in_min_contig_length", input_type=Int(optional=True), prefix="-L", doc=InputDocumentation(doc=":min contig length to be reported (default: 25)")), ToolInput(tag="in_min_assembly_coverage", input_type=Boolean(optional=True), prefix="--min_assembly_coverage", doc=InputDocumentation(doc="<int>   :min kmer coverage of an assembled contig to be reported (default: 2)")), ToolInput(tag="in_coverage_outfile", input_type=File(optional=True), prefix="--coverage_outfile", doc=InputDocumentation(doc=":file to store per-base kmer coverage for contigs")), ToolInput(tag="in_ds", input_type=Boolean(optional=True), prefix="--DS", doc=InputDocumentation(doc=":double-stranded RNA-Seq mode (not strand-specific)")), ToolInput(tag="in_no_prune_error_km_ers", input_type=Boolean(optional=True), prefix="--no_prune_error_kmers", doc=InputDocumentation(doc=":disable pruning of kmers that occur at below --min_ratio_non_error")), ToolInput(tag="in_min_ratio_non_error", input_type=Float(optional=True), prefix="--min_ratio_non_error", doc=InputDocumentation(doc=":min ratio for low/high alternative extension that is not an error (default: 0.05)")), ToolInput(tag="in_num_threads", input_type=Int(optional=True), prefix="--num_threads", doc=InputDocumentation(doc=":number of threads to use.")), ToolInput(tag="in_monitor", input_type=Int(optional=True), prefix="--monitor", doc=InputDocumentation(doc=":verbosity. ( '1': recommended, '2': for debugging )")), ToolInput(tag="in_show_advanced", input_type=Boolean(optional=True), prefix="--show_advanced", doc=InputDocumentation(doc=":more advanced options (mostly experimental)"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Inchworm_V0_1_0().translate("wdl", allow_empty_container=True)

